"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var constants_1 = require("../model/constants");
function find(arr, func) {
    for (var i = 0; i < arr.length; i++) {
        if (func(arr[i])) {
            return arr[i];
        }
    }
    return null;
}
exports.find = find;
function mooaLog() {
    var args = [];
    for (var _i = 0; _i < arguments.length; _i++) {
        args[_i] = arguments[_i];
    }
    if (window['mooa'] && window['mooa']['debug']) {
        console.log(args);
    }
}
exports.mooaLog = mooaLog;
// Fixed for IE Custom Event
function MooaCustomEvent(event, params) {
    params = params || { bubbles: false, cancelable: false, detail: undefined };
    var evt = document.createEvent('CustomEvent');
    evt.initCustomEvent(event, params.bubbles, params.cancelable, params.detail);
    return evt;
}
function customEvent(eventName, eventArgs) {
    if (typeof window.CustomEvent !== 'function') {
        MooaCustomEvent.prototype = window.Event.prototype;
        window.CustomEvent = MooaCustomEvent;
    }
    window.dispatchEvent(new CustomEvent(eventName, { detail: eventArgs }));
}
exports.customEvent = customEvent;
function navigateAppByName(opts) {
    var navigateToApp;
    window.apps.map(function (app) {
        app.status = constants_1.StatusEnum.NOT_LOADED;
        if (app.name === opts.appName) {
            app.status = constants_1.StatusEnum.NOT_LOADED;
            navigateToApp = app;
            return app;
        }
    });
    if (navigateToApp) {
        history.pushState(null, '', navigateToApp.appConfig.prefix + '/' + opts.router);
        window.mooa.instance.reRouter();
    }
}
exports.navigateAppByName = navigateAppByName;
function hashCode(str) {
    var hash = 0;
    if (str.length === 0) {
        return hash.toString();
    }
    for (var i = 0; i < str.length; i++) {
        hash = (hash << 5) - hash + str.charCodeAt(i);
        hash = hash & hash;
        hash = hash >>> 1;
    }
    return hash.toString();
}
exports.hashCode = hashCode;
//# sourceMappingURL=app.helper.js.map