"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var cli_help_1 = require("./cli.help");
var fs = require('fs');
function generate(program) {
    var urlListFilePath = program.args[0];
    var filePath = process.cwd() + '/' + urlListFilePath;
    if (fs.existsSync(filePath)) {
        var urlFile = fs.readFileSync(filePath, 'utf8');
        var urls = urlFile.split(/\r?\n/);
        cli_help_1.getAppsConfig(urls).then(function (apps) {
            fs.writeFileSync(process.cwd() + '/apps.json', JSON.stringify(apps, null, 2));
        });
    }
}
exports.default = generate;
//# sourceMappingURL=generate.js.map