"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
/**
 * Robin Coma Delperier
 * Licensed under the Apache-2.0 License
 * https://github.com/PlaceMe-SAS/single-spa-angular-cli/blob/master/LICENSE
 *
 * modified by Phodal HUANG
 *
 */
var app_helper_1 = require("./app.helper");
var createScriptTag = function (src) {
    var script = document.createElement('script');
    script.type = 'text/javascript';
    script.src = src;
    script.charset = 'UTF-8';
    script.id = app_helper_1.hashCode(src);
    return script;
};
var createLinkTag = function (src) {
    var link = document.createElement('link');
    link.rel = 'stylesheet';
    link.href = src;
    link.type = 'text/css';
    link.charset = 'UTF-8';
    link.id = app_helper_1.hashCode(src);
    return link;
};
var assetsLoaderHelper = {
    createScriptTag: createScriptTag,
    createLinkTag: createLinkTag
};
exports.default = assetsLoaderHelper;
//# sourceMappingURL=assets-loader.helper.js.map