"use strict";
var AppHelper = require('../../helper/app.helper');
test('should be able to find app name', function () {
    var apps = [{ name: 'app1' }, { name: 'help' }];
    var findApp = AppHelper.find(apps, function (app) {
        return app.name === 'help';
    });
    expect(findApp.name).toBe('help');
});
test('should be unable to find app name', function () {
    var apps = [{ name: 'app1' }, { name: 'help' }];
    var isFind = AppHelper.find(apps, function (app) {
        return app.name === 'help1';
    });
    expect(isFind).toBe(null);
});
test('should be able to call console log', function () {
    global.console.log = jest.fn();
    Object.defineProperty(window, 'mooa', function () {
        return true;
    });
    AppHelper.mooaLog('hello', 'world');
    // expect(global.console.log).toHaveBeenCalled()
});
//# sourceMappingURL=app.helper.spec.js.map