"use strict";
var assetsLoaderHelper = require('../../helper/assets-loader.helper').default;
test('should get hash code', function () {
    var hash = assetsLoaderHelper.hashCode('hello, world');
    expect(hash).toBe('543394210');
});
test('should be able create script tag', function () {
    var scriptTag = assetsLoaderHelper.createScriptTag('/test.js');
    var tmp = document.createElement('div');
    tmp.appendChild(scriptTag);
    expect(tmp.innerHTML).toBe('<script type="text/javascript" src="/test.js" charset="UTF-8" id="1494346482"></script>');
});
test('should be able create style tag', function () {
    var scriptTag = assetsLoaderHelper.createLinkTag('/style.css');
    var tmp = document.createElement('div');
    tmp.appendChild(scriptTag);
    expect(tmp.innerHTML).toBe('<link rel="stylesheet" href="/style.css" type="text/css" charset="UTF-8" id="2145530989">');
});
//# sourceMappingURL=assets-loader.helper.spec.js.map