"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var status_helper_1 = require("../../helper/status.helper");
var constants_1 = require("../../model/constants");
test('should be able to find app name', function () {
    var activeApps = status_helper_1.default.getActiveApps([
        {
            status: constants_1.StatusEnum.SKIP_BECAUSE_BROKEN
        },
        {
            status: constants_1.StatusEnum.MOUNTED
        }
    ]);
    expect(activeApps).toEqual([{ status: 'MOUNTED' }]);
});
test('should be able to find app name', function () {
    var activeApps = status_helper_1.default.getAppsToMount([
        {
            status: constants_1.StatusEnum.MOUNTED
        },
        {
            status: constants_1.StatusEnum.SKIP_BECAUSE_BROKEN
        },
        {
            status: constants_1.StatusEnum.NOT_LOADED
        },
        {
            status: constants_1.StatusEnum.LOADING_SOURCE_CODE
        },
        {
            status: constants_1.StatusEnum.NOT_MOUNTED,
            activeWhen: function (parms) {
                return true;
            }
        }
    ]);
    expect(activeApps[0].status).toEqual('NOT_MOUNTED');
});
//# sourceMappingURL=status.helper.spec.js.map